package models

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

type CygxReportHistoryRecord struct {
	Id          int `orm:"column(id);pk"`
	ArticleId   int
	UserId      int
	CreateTime  time.Time
	Mobile      string    `description:"手机号"`
	Email       string    `description:"邮箱"`
	CompanyId   int       `description:"公司id"`
	CompanyName string    `description:"公司名称"`
	ModifyTime  time.Time `description:"修改时间"`
	ReportType  string    `description:"报告类型，bgjx:报告精选、bzyjhz:本周研究汇总、szjyhz:上周纪要汇总"`
	RealName    string    `description:"用户实际名称"`
	SellerName  string    `description:"所属销售"`
}

//添加历史信息
func AddCygxReportHistoryRecord(item *CygxReportHistoryRecord) (lastId int64, err error) {
	o := orm.NewOrm()
	item.ModifyTime = time.Now()
	lastId, err = o.Insert(item)
	return
}
