package models

type ApifoxModal struct {
	ErrorCode interface{} `json:"errorCode"`
	ErrorMsg  interface{} `json:"errorMsg"`
	Result    []Result    `json:"result"`
	Success   bool        `json:"success"`
	Timestamp int64       `json:"timestamp"`
}

type Result struct {
	ActivityJoinType               string  `json:"activityJoinType"`               // 活动入会类型，01报名审核后可入会 02预约即可入会 03仅定向邀请人员可入会
	Banner                         string  `json:"banner"`                         // 宣传图
	BusinessCardOpen               string  `json:"businessCardOpen"`               // 上传名片是否开启，1是 0否
	BusinessCardRequired           string  `json:"businessCardRequired"`           // 上传名片是否必填，1是 0否
	CertificateInformationOpen     string  `json:"certificateInformationOpen"`     // 证件信息是否开启，1是 0否
	CertificateInformationRequired string  `json:"certificateInformationRequired"` // 证件信息是否必填，1是 0否
	CompanyCodeOpen                string  `json:"companyCodeOpen"`                // 公司代码是否开启，1是 0否
	CompanyCodeRequired            string  `json:"companyCodeRequired"`            // 公司代码是否必填，1是 0否
	CompanyInfo                    string  `json:"companyInfo"`                    // 公司名称
	CompanyShortNameOpen           string  `json:"companyShortNameOpen"`           // 公司名称是否开启，1是 0否
	CompanyShortNameRequired       string  `json:"companyShortNameRequired"`       // 公司名称是否必填，1是 0否
	End                            string  `json:"end"`                            // 活动结束时间
	ID                             string  `json:"id"`                             // 活动主键id
	IndustrySwName                 string  `json:"industrySwName"`                 // 行业
	InviteeOpen                    *string `json:"inviteeOpen"`                    // 邀请机构是否开启，1是 0否
	InviteeRequired                *string `json:"inviteeRequired"`                // 邀请机构是否必填，1是 0否
	JobNameOpen                    string  `json:"jobNameOpen"`                    // 职务是否开启，1是 0否
	JobNameRequired                string  `json:"jobNameRequired"`                // 职务是否必填，1是 0否
	MailOpen                       string  `json:"mailOpen"`                       // 邮箱是否开启，1是 0否
	MailRequired                   string  `json:"mailRequired"`                   // 邮箱是否必填，1是 0否
	PersonNameOpen                 string  `json:"personNameOpen"`                 // 姓名是否开启，1是 0否
	PersonNameRequired             string  `json:"personNameRequired"`             // 姓名是否必填，1是 0否
	PersonTelephoneOpen            string  `json:"personTelephoneOpen"`            // 手机号是否开启，1是 0否
	PersonTelephoneRequired        string  `json:"personTelephoneRequired"`        // 手机号是否必填，1是 0否
	SignUpEnd                      string  `json:"signUpEnd"`                      // 报名结束时间，适应于报名审核后可入会，为空表示不限制报名时间
	SignUpStart                    string  `json:"signUpStart"`                    // 报名开始时间，适应于报名审核后可入会，为空表示不限制报名时间
	Start                          string  `json:"start"`                          // 活动开始时间
	SyncFlag                       string  `json:"syncFlag"`                       // 同步有效性，同步有效性 1有效，0失效
	Title                          string  `json:"title"`                          // 活动主题
	Type                           string  `json:"type"`                           // 路演类型
	URL                            string  `json:"url"`                            // 活动短链接
}

type ApifoxModalDetail struct {
	ErrorCode interface{} `json:"errorCode"`
	ErrorMsg  interface{} `json:"errorMsg"`
	Result    Result      `json:"result"`
	Success   bool        `json:"success"`
	Timestamp int64       `json:"timestamp"`
}

type ResultDetail struct {
	GuestIntroduceType string     `json:"guestIntroduceType"` // 嘉宾类型，嘉宾类型（0-列表，1-图片）
	GuestPersonList    []UserList `json:"guestPersonList"`    // 嘉宾列表，适用列表类型
	GuestPicURL        string     `json:"guestPicUrl"`        // 嘉宾图片链接，适用图片类型
}

type UserList struct {
	CompanyName        string  `json:"companyName"`        // 公司
	HeadPortraitURL    string  `json:"headPortraitUrl"`    // 头像
	ID                 string  `json:"id"`                 // 嘉宾主键id
	JobName            string  `json:"jobName"`            // 职务
	PersonIntroduction *string `json:"personIntroduction"` // 嘉宾介绍
	PersonName         string  `json:"personName"`         // 姓名
}

type ApifoxModaldetail struct {
	ErrorCode    interface{}  `json:"errorCode"`
	ErrorMsg     interface{}  `json:"errorMsg"`
	Resultdetail Resultdetail `json:"result"`
	Success      bool         `json:"success"`
	Timestamp    int64        `json:"timestamp"`
}

type Resultdetail struct {
	GuestIntroduceType string `json:"guestIntroduceType"` // 嘉宾类型，嘉宾类型（0-列表，1-图片）
	GuestPersonList    []嘉宾列表 `json:"guestPersonList"`    // 嘉宾列表，适用列表类型
	GuestPicURL        string `json:"guestPicUrl"`        // 嘉宾图片链接，适用图片类型
}

type 嘉宾列表 struct {
	CompanyName        string  `json:"companyName"`        // 公司
	HeadPortraitURL    string  `json:"headPortraitUrl"`    // 头像
	ID                 string  `json:"id"`                 // 嘉宾主键id
	JobName            string  `json:"jobName"`            // 职务
	PersonIntroduction *string `json:"personIntroduction"` // 嘉宾介绍
	PersonName         string  `json:"personName"`         // 姓名
}

type ApifoxModaluser struct {
	ErrorCode interface{}  `json:"errorCode"`
	ErrorMsg  interface{}  `json:"errorMsg"`
	Result    []Resultuser `json:"result"`
	Success   bool         `json:"success"`
	Timestamp int64        `json:"timestamp"`
}

type Resultuser struct {
	DeviceType      *int64 `json:"deviceType"`                // 参会方式，1-PC，2-Mac，3-Android，4-IOS，5-Web，6-iPad，7-Android Pad，8-小程序
	Duration        string `json:"duration"`                  // 参会时长
	EndTime         string `json:"endTime"`                   // 最后退会时间
	ID              string `json:"id,omitempty"`              // 主键id
	PersonTelephone string `json:"personTelephone,omitempty"` // 用户手机号
	StartTime       string `json:"startTime"`                 // 最早入会时间
	Status          string `json:"status"`                    // 状态，D表示被删除
	UserID          string `json:"userId,omitempty"`          // 用户id
}

type ApifoxModalUserTgc struct {
	Result  结果Map `json:"result"`  // 结果Map
	Success bool  `json:"success"` // 成功标识，可作为请求是否成功标识
}

// 结果Map
type 结果Map struct {
	Tgc    string `json:"tgc"`    // tgc，跳转H5时拼接用
	UserID string `json:"userId"` // 用户ID
}

type ApifoxModalSingUpClass struct {
	ErrorCode *string   `json:"errorCode"` // 错误码，001：活动不存在；002：该活动不支持此渠道报名；003：该手机号或邮箱已经被其他账号提交报名；004：不在报名时间；005：报名人数已满
	ErrorMsg  *string   `json:"errorMsg"`  // 错误信息
	Result    SingUpMap `json:"result"`    // 结果Map，成功
	Success   bool      `json:"success"`   // 成功标识，true：成功；false：失败。可作为判断报名是否成功的标识
	Timestamp float64   `json:"timestamp"` // 时间戳
}

type SingUpMap struct {
	Msg string `json:"msg"` // 请求信息，成功信息
}

type ApifoxgetOriginalLink struct {
	Result    string  `json:"result"`    // 结果Map
	Success   bool    `json:"success"`   // 成功标识，可作为请求是否成功标识
	ErrorCode *string `json:"errorCode"` // 错误码，001：活动不存在；002：该活动不支持此渠道报名；003：该手机号或邮箱已经被其他账号提交报名；004：不在报名时间；005：报名人数已满
	ErrorMsg  *string `json:"errorMsg"`  // 错误信息
	Timestamp float64 `json:"timestamp"` // 时间戳
}
