package services

import (
	"errors"
	"hongze/hongze_cygx/models"
	"hongze/hongze_cygx/utils"
)

// GetActivitySignupResp 处理用户的报名方式
func GetActivitySignupResp(activityIdS []int, user *models.WxUserItem) (mapItem map[int]int, err error) {
	var condition string
	var pars []interface{}
	lenActivityId := len(activityIdS)
	if lenActivityId == 0 || user.Mobile == "" {
		return
	}
	condition = ` AND do_fail_type = 0 AND activity_id IN (` + utils.GetOrmInReplace(lenActivityId) + `) AND mobile = ?`
	pars = append(pars, activityIdS, user.Mobile)

	listSignup, e := models.GetActivitySignupList(condition, pars)
	if e != nil {
		err = errors.New("GetResourceDataList, Err: " + e.Error())
		return
	}
	mapItem = make(map[int]int, 0)
	for _, v := range listSignup {
		mapItem[v.ActivityId] = v.SignupType
	}
	return
}
