package services

import (
	"hongze/hongze_cygx/models"
	"time"
)

//添加活动的视频播放记录
func AddActivityVideoHistory(user *models.WxUserItem, activityId int) (err error) {
	activityInfo, errInfo := models.GetCygxActivityVideoByActivityId(activityId)
	if activityInfo == nil {
		return
	}
	if errInfo != nil {
		return
	}
	var sellerName string
	sellerName, err = models.GetCompanySellerName(user.CompanyId)
	if err != nil {
		return
	}
	item := models.CygxActivityVideoHistory{
		ActivityId:  activityInfo.ActivityId,
		VideoId:     activityInfo.VideoId,
		UserId:      user.UserId,
		CreateTime:  time.Now(),
		Mobile:      user.Mobile,
		Email:       user.Email,
		CompanyId:   user.CompanyId,
		CompanyName: user.CompanyName,
		RealName:    user.RealName,
		SellerName:  sellerName,
		ModifyTime:  time.Now(),
	}
	err = models.AddCygxActivityVideoHistory(&item)
	if err != nil {
		return
	}
	err = models.UpdateActivityVideoCounts(activityInfo.ActivityId)
	if err != nil {
		return
	}
	go ActivityVideoUserRmind(user, activityId, 1)
	return
}
